import 'dart:async';

import 'package:flutter/services.dart';
import 'dart:convert';

class NotificationEvent {
  Map<String,Object> _package;
  DateTime _timeStamp;

  NotificationEvent(String sevent) {
    this._package=json.decode(sevent);
    _timeStamp = DateTime.now();
  }

  Map<String,Object> get packageName => _package;
  DateTime get timeStamp => _timeStamp;

  @override
  String toString() {
    return "[$packageName sent notification @ $timeStamp";
  }
}

NotificationEvent _notificationEvent(String event) {
  return new NotificationEvent(event);
}

class Notifications {
  static const EventChannel _notificationEventChannel =
      EventChannel('notifications.eventChannel');

  Stream<NotificationEvent> _notificationStream;

  Stream<NotificationEvent> get stream {
    if (_notificationStream == null) {
      _notificationStream = _notificationEventChannel
          .receiveBroadcastStream()
          .map((event) => _notificationEvent(event));
    }
    return _notificationStream;
  }
}
